# ==================================================================
# Plugins::Guess - Auto Generated Install Module
#
#   Plugins::Guess
#   Author  : Andy Newby
#   Version : 1
#   Updated : Wed Jun 12 14:22:04 2002
#
# ==================================================================
#

package Plugins::Guess;
# ==================================================================
    use strict;
    use vars  qw/$VERSION $DEBUG $NAME $META/;
    use GT::Base;
    use GT::Plugins qw/STOP CONTINUE/;
    use Links qw/$CFG $IN $DB/;

    $VERSION = '1';
    $DEBUG   = 0;
    $NAME    = 'Guess';
# Inhert from base class for debug and error methods
    @Plugins::Guess::ISA = qw(GT::Base);

    $META = {
    'prog_ver' => '2.1.0',
    'description' => 'Just a little game. Insert a tag into your pages, and it will show a box with a number 1 to 50. They have to guess the number...and if they do...well, they can feel happy about themselves :p',
    'license' => 'Freeware',
    'url' => 'http://www.ace-installer.com',
    'author' => 'Andy Newby',
    'version' => '1'
};


sub pre_install {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they install
# the plugin.
#
    my $inst_msg = 'Just a little game. Insert a tag into your pages, and it will show a box with a number 1 to 50. They have to guess the number...and if they do...well, they can feel happy about themselves :p';

    return $inst_msg;
}

sub pre_uninstall {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they remove the
# plugin.
#
    my $uninst_msg = 'Sorry to see you are uninstalling. Thanks for trying it though.';

    return $uninst_msg;
}

sub install {
# -------------------------------------------------------------------
# This function does the actual installation. It's first argument is
# a plugin manager which you can use to register hooks, install files,
# add menu options, etc. The second argument is a GT::Tar object which
# you can use to access any files in your plugin module.
#
# You should return an HTML formatted string that will be displayed 
# to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Guess::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_menu ( 'Guess', [ ['Readme', 'admin.cgi?do=plugin&plugin=Guess&func=Readme'] ] );
    $mgr->install_menu ( 'Guess', [ ['Our Site', 'admin.cgi?do=plugin&plugin=Guess&func=Our_Site'] ] );
    $mgr->install_menu ( 'Guess', [ ['Donate', 'admin.cgi?do=plugin&plugin=Guess&func=Donate'] ] );
    $mgr->install_options ( 'Guess', [ ['Min_Number', '1', 'This is the minimum number you want them to be able to choose..', 'TEXT', []
, []
, '' ] ] );
    $mgr->install_options ( 'Guess', [ ['Max_Number', '50', 'This is the maximum number you want them to be able to choose...', 'TEXT', []
, []
, '' ] ] );
    ;

# Silence warnings
    $GT::Tar::error ||= '';

# set the global variables..
    my (@script,$line,$cgi_code);

# The following section will unarchive attached files into the 
# proper location.
    my $class = 'Plugins::Guess';
    my $file;

# Chmod the cgi-bin to 777 so we can write to it.
    chmod(0777, "$CFG->{admin_root_path}/../");


# Copying guess.cgi to $CFG->{admin_root_path}/.. directory.
    $file = $tar->get_file ('guess.cgi') or return $class->error("Unable to extract guess.cgi ($GT::Tar::error)");
    $file->name("$CFG->{admin_root_path}/../guess.cgi");
    $file->write or return $class->error("Unable to extract file: '$CFG->{admin_root_path}/../guess.cgi' ($GT::Tar::error)", 'WARN');

# Copying guess_success.html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/ directory.
    $file = $tar->get_file ('guess_success.html') or return $class->error("Unable to extract guess_success.html ($GT::Tar::error)");
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/guess_success.html");
    $file->write or return $class->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/guess_success.html' ($GT::Tar::error)", 'WARN');

# Copying guess_incorrect_html to $CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/ directory.
    $file = $tar->get_file ('guess_incorrect.html') or return $class->error("Unable to extract guess_incorrect.html ($GT::Tar::error)");
    $file->name("$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/guess_incorrect.html");
    $file->write or return $class->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{build_default_tpl}/guess_incorrect.html' ($GT::Tar::error)", 'WARN');


# Get the entire code as a string. 
    open(CGI_SCRIPT,"$CFG->{admin_root_path}/../guess.cgi") or return $class->error("Unable to read guess.cgi ($GT::Tar::error)", 'WARN');
    @script = <CGI_SCRIPT>;
    close(CGI_SCRIPT);
    
    # put code into a variable..so we cna regex it ;)
    foreach $line (@script) { $cgi_code .= $line; }

# Do some substitutions. 
    $cgi_code =~ s/^#!(.*)/#!$CFG->{path_to_perl}/; 
    $cgi_code =~ s/use lib '';/use lib '$CFG->{admin_root_path}';/; 
    $cgi_code =~ s,Links::init\(\),Links::init('$CFG->{admin_root_path}'),;

# Update the file to the new body. 
    open(CGI_SCRIPT,">$CFG->{admin_root_path}/../guess.cgi") or return $class->error("Unable to write guess.cgi ($GT::Tar::error)", 'WARN');
    print CGI_SCRIPT $cgi_code;
    close(CGI_SCRIPT);

# Chmod the guess.cgi to 755 so we can write to it.
    chmod(0755, "$CFG->{admin_root_path}/../guess.cgi");

# Chmod the cgi-bin back to 755.
    chmod(0755, "$CFG->{admin_root_path}/../");


    return "The plugin has been successfully installed!";
}

sub uninstall {
# -------------------------------------------------------------------
# This function removes the plugin. It's first argument is
# also a plugin manager which you can use to register hooks, install files,
# add menu options, etc. You should return an HTML formatted string
# that will be displayed to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Guess::error
#
    my $mgr = shift;
    
    $mgr->uninstall_menu ( 'Guess', [ ['Readme', 'admin.cgi?do=plugin&plugin=Guess&func=Readme'] ] );
    $mgr->uninstall_menu ( 'Guess', [ ['Our Site', 'admin.cgi?do=plugin&plugin=Guess&func=Our_Site'] ] );
    $mgr->uninstall_menu ( 'Guess', [ ['Donate', 'admin.cgi?do=plugin&plugin=Guess&func=Donate'] ] );
    $mgr->uninstall_options ( 'Guess', [ ['Min_Number', '1', 'This is the minimum number you want them to be able to choose..', 'TEXT', []
, []
, '' ] ] );
    $mgr->uninstall_options ( 'Guess', [ ['Max_Number', '50', 'This is the maximum number you want them to be able to choose...', 'TEXT', []
, []
, '' ] ] );
    ;
    
     # get rid of guess.cgi...
    unlink("$CFG->{admin_root_path}/../guess.cgi");

    return "The plugin has been successfully removed!";
}

1;
